//package com.gx.obe.step.price.dataset;
//
//import java.math.BigDecimal;
//import java.util.ArrayList;
//import java.util.List;
//import java.util.Map;
//import java.util.Objects;
//import java.util.Optional;
//import java.util.function.Function;
//import java.util.stream.Collectors;
//import java.util.stream.Stream;
//
//import com.gx.obe.business.entity.SupplierEvaluationStep;
//import com.gx.obe.components.core.enumeration.EvaluationStepEnum;
//import com.gx.obe.components.core.enumeration.PriceReviewTypeEnum;
//import com.gx.obe.components.core.util.MoneyUtils;
//import com.gx.obe.step.price.beans.PriceDetail;
//import com.gx.obe.step.price.beans.PriceDetailEvalResult;
//import com.gx.obe.step.price.beans.SupplierPriceDetail;
//import com.gx.obe.step.price.beans.SupplierPriceDetailEvalResult;
//import com.gx.obe.step.price.service.PriceDetailEvalResultService;
//import com.gx.obe.step.price.service.PriceDetailService;
//import com.gx.obe.step.price.utils.MapUtils;
//import com.gx.obe.util.utils.CollectionUtils;
//import com.gx.obe.web.entity.Supplier;
//import com.gx.obe.web.entity.evaluation.EvaluationFactor;
//import com.gx.obe.web.entity.evaluation.EvaluationStep;
//import com.gx.obe.web.service.SupplierEvaluationStepService;
//import com.gx.obe.web.service.SupplierService;
//import com.gx.obe.web.service.evaluation.EvaluationFactorService;
//import com.gx.obe.web.service.evaluation.EvaluationStepService;
//
///**
// * @Description: 价格明细评审结果数据集
// * @author chenxw
// */
//public class PriceDetailEvalResultDo {
//	
//	private final EvaluationStepService evaluationStepService = new EvaluationStepService();
//	private final SupplierService supplierService = new SupplierService();
//	private final SupplierEvaluationStepService supplierEvaluationStepService = new SupplierEvaluationStepService();
//	private final EvaluationFactorService evaluationFactorService = new EvaluationFactorService();
//	
//	private List<SupplierDto> supplierDtoList;
//	private List<PriceDetailDto> priceDetailDtoList;
//	private List<SubCrossData> subCrossDataList;
//	
//	private String tenderId;
//	private String priceUnit;
//	
//	/**
//	 * @author chenxw
//	 * @param tenderId
//	 */
//	public PriceDetailEvalResultDo(String tenderId, String priceUnit) {
//		this.tenderId = tenderId;
//		this.priceUnit = priceUnit;
//		init();
//	}
//	
//	private void init() {
//		List<EvaluationStep> priceEvalStepList = evaluationStepService.getEvaluationStepListByType(tenderId, EvaluationStepEnum.PRICE);
//		if (CollectionUtils.isNull(priceEvalStepList)) {
//			return;
//		}
//		EvaluationStep priceDetailEvalStep = priceEvalStepList.stream().filter(t -> PriceReviewTypeEnum.DETAIL.equals(t.getEvaluationParamByKey(EvaluationStepEnum.PRICE_REVIEW_TYPE))).findAny().orElse(null);
//		if (Objects.isNull(priceDetailEvalStep)) {
//			return;
//		}
//		
//		initSupplierDtoList(priceDetailEvalStep);
//		initPriceDetailEvalResult(priceDetailEvalStep);
//	}
//
//	/**
//	 * @Description: 初始化供应商信息列表
//	 * @author chenxw
//	 * @param tenderId
//	 * @param priceDetailEvalStep
//	 */
//	private void initSupplierDtoList(EvaluationStep priceDetailEvalStep) {
//		List<Supplier> supplierList = supplierService.getEvaluationStepSupplierList(tenderId, priceDetailEvalStep);
//		if (CollectionUtils.isNull(supplierList)) {
//			return;
//		}
//		List<SupplierEvaluationStep> supplierEvaluationStepList = Optional.ofNullable(supplierEvaluationStepService.getSupplierEvaluationStepByTenderIdAndStepId(tenderId, priceDetailEvalStep.getId())).orElseGet(ArrayList::new);
//		Map<String, SupplierEvaluationStep> supplierEvalStepMap = supplierEvaluationStepList.stream().collect(Collectors.toMap(SupplierEvaluationStep::getSupplierId, Function.identity()));
//		supplierDtoList = supplierList.stream().map(t -> {
//			SupplierDto supplierDto = new SupplierDto();
//			supplierDto.setSupplierId(t.getId());
//			supplierDto.setSupplierName(t.getSupplierName());
//			if (supplierEvalStepMap.containsKey(t.getId())) {
//				SupplierEvaluationStep supplierEvalStep = supplierEvalStepMap.get(t.getId());
//				supplierDto.setTotalScore(supplierEvalStep.getEvaluationScore());
//				supplierDto.setSortNo(supplierEvalStep.getSortNo());
//			}
//			return supplierDto;
//		}).collect(Collectors.toList());
//	}
//	
//	/**
//	 * @Description: 初始化报价明细评审结果
//	 * @author chenxw
//	 * @param tenderId
//	 * @param priceDetailEvalStep
//	 */
//	private void initPriceDetailEvalResult(EvaluationStep priceDetailEvalStep) {
//		List<EvaluationFactor> evaluationTopFactorList = evaluationFactorService.getFactorListByStepId(tenderId, priceDetailEvalStep.getId());
//		EvaluationFactor evaluationFactor = Optional.ofNullable(evaluationTopFactorList).map(List::stream).flatMap(Stream::findFirst).orElse(null);
//		if (Objects.isNull(evaluationFactor)) {
//			return;
//		}
//		List<PriceDetail> priceDetailList = PriceDetailService.getPriceDetailList(tenderId, evaluationFactor.getBidPriceCode());
//		if (CollectionUtils.isNull(priceDetailList)) {
//			return;
//		}
//		List<PriceDetailEvalResult> evalResultList = Optional.of(tenderId).map(PriceDetailEvalResultService::getPriceDetailEvalResultList).orElseGet(ArrayList::new);
//		initPriceDetailDtoList(priceDetailList, evalResultList);
//		initSubCrossDataList(priceDetailList, evalResultList);
//	}
//	
//	/**
//	 * @Description: 初始化报价明细信息列表
//	 * @author chenxw
//	 * @param priceDetailList
//	 * @param evalResultList
//	 */
//	private void initPriceDetailDtoList(List<PriceDetail> priceDetailList, List<PriceDetailEvalResult> evalResultList) {
//		Map<String, BigDecimal> priceDetailBasePriceMap = evalResultList.stream().collect(Collectors.toMap(PriceDetailEvalResult::getDetailCode, PriceDetailEvalResult::getBasePrice));
//		priceDetailDtoList = priceDetailList.stream().map(t -> {
//			PriceDetailDto priceDetailDto = new PriceDetailDto();
//			priceDetailDto.setDetailId(t.getDetailCode());
//			priceDetailDto.setDetailCode(t.getDetailCode().trim());
//			if (priceDetailBasePriceMap.containsKey(t.getDetailCode())) {
//				priceDetailDto.setBasePrice(MoneyUtils.getMoneyByUnit(priceDetailBasePriceMap.get(t.getDetailCode()), priceUnit));
//			}
//			return priceDetailDto;
//		}).collect(Collectors.toList());
//	}
//	
//	/**
//	 * @Description: 初始化
//	 * @author chenxw
//	 * @param priceDetailList
//	 * @param evalResultList
//	 */
//	private void initSubCrossDataList(List<PriceDetail> priceDetailList, List<PriceDetailEvalResult> evalResultList) {
//		Map<String, Map<String, BigDecimal>> supplierPriceDetailScoreMapMap = evalResultList.stream().collect(Collectors.toMap(PriceDetailEvalResult::getDetailCode, t -> {
//			return t.getSupplierPriceDetailEvalResultList().stream().collect(Collectors.toMap(SupplierPriceDetailEvalResult::getSupplierId, SupplierPriceDetailEvalResult::getScore));
//		}));
//		subCrossDataList = priceDetailList.stream().flatMap(t -> {
//			List<SupplierPriceDetail> supplierDetailList = t.getSupplierPriceDetailList();
//			if (CollectionUtils.isNull(supplierDetailList)) {
//				return null;
//			}
//			Map<String, BigDecimal> supplierPriceDetailScoreMap = supplierPriceDetailScoreMapMap.get(t.getDetailCode());
//			if (MapUtils.isNull(supplierPriceDetailScoreMap)) {
//				return null;
//			}
//			return supplierDetailList.stream().map(s -> {
//				SubCrossData subCrossData = new SubCrossData();
//				subCrossData.setSupplierId(s.getSupplierId());
//				subCrossData.setDetailId(t.getDetailCode());
//				subCrossData.setPrice(MoneyUtils.getMoneyFromText(s.getEvalPrice(), priceUnit));
//				if (supplierPriceDetailScoreMap.containsKey(s.getSupplierId())) {
//					subCrossData.setScore(supplierPriceDetailScoreMap.get(s.getSupplierId()));
//				}
//				return subCrossData;
//			});
//		}).collect(Collectors.toList());
//	}
//
//	public List<SupplierDto> getSupplierDtoList() {
//		return supplierDtoList;
//	}
//
//	public List<PriceDetailDto> getPriceDetailDtoList() {
//		return priceDetailDtoList;
//	}
//
//	public List<SubCrossData> getSubCrossDataList() {
//		return subCrossDataList;
//	}
//	
//}
